#include "Osoba.h"

Osoba::Osoba(const char* im, const char* naz)
{
	cout << "Konstruktor zwykly Osoby: ";
	imie = new char[strlen(im)+1]; //+1 bo '\0'
	nazwisko = new char[strlen(naz)+1];
	strcpy(imie, im);
	strcpy(nazwisko, naz);
	Wypisz();
}

Osoba::Osoba(const Osoba& wzor)
{
	//imie = wzor.imie;
	//nazwisko = wzor.nazwisko;

	cout << "Konstruktor kopiujacy Osoby: ";
	imie = new char[strlen(wzor.imie)+1];
	nazwisko = new char[strlen(wzor.nazwisko)+1];
	strcpy(imie, wzor.imie);
	strcpy(nazwisko, wzor.nazwisko);
	Wypisz();
}

Osoba::~Osoba()
{
	cout << "Destruktor Osoby: ";
	if (imie && nazwisko) Wypisz();
	delete[] imie;
	delete[] nazwisko;
	imie = nullptr;
	nazwisko = nullptr;

}

void Osoba::Wypisz() const
{
	cout << imie << ' ' << nazwisko<<endl;
}

void Osoba::WypiszExtra() const
{
	cout << "My name is " << nazwisko << ", ";
	Wypisz();
}

void Osoba::ZmienImie(const char* nowe)
{
	delete[] imie;
	imie = new char[strlen(nowe) + 1];
	strcpy(imie, nowe);
}

Osoba& Osoba::operator=(const Osoba& wzor)
{
	cout << "Operator= ";
	if (&wzor != this)
	{
		//cze destruktorowa
		//this->~Osoba();
		
		delete[] imie;
		delete[] nazwisko;

		//cze konst. kopiujcego
		imie = new char[strlen(wzor.imie) + 1];
		nazwisko = new char[strlen(wzor.nazwisko) + 1];
		strcpy(imie, wzor.imie);
		strcpy(nazwisko, wzor.nazwisko);
		//new (this) Osoba(wzor);
		//this->Osoba::Osoba(wzor); //VS
	}
	Wypisz();
	return *this;
}
